@echo off
Setlocal EnableDelayedExpansion
 
::begin
:BEGIN
cls
echo ================================================
echo ===========Rosa Kart Wii ISO Builder============
echo ================================================
echo ====================by Fancy====================
echo =============Powered by WIT by Wiimm============
echo ================================================
pause

:: Version Select Menu
cls
echo ========Base ISO Version Select=========
echo 1. USA
echo 2. EUR
echo 3. JPN
echo.
echo =====Enter the Number corresponding=====
echo ======to your MKWII image version=======
SET VERINPUT=
SET /P VERINPUT=Enter Number and press Enter:

IF %VERINPUT%==1 (
	SET BASEVER=USA
	SET GAMEID=RMCE01
	GOTO FORMAT
	)
IF %VERINPUT%==2 (
	SET BASEVER=EUR
	SET GAMEID=RMCP01
	GOTO FORMAT
	)
IF %VERINPUT%==3 (
	SET BASEVER=JPN
	SET GAMEID=RMCJ01
	GOTO FORMAT
	)

GOTO INPUTERROR

:FORMAT
cls
echo ========Format Select=========
echo 1. ISO (useful for Dolphin/burned discs)
echo 2. WBFS (useful for USB loaders)
echo =====Enter the Number corresponding=====
echo ========to the filetype you want========
SET FMTINPUT=
SET /P FMTINPUT=Enter Number and press Enter:

IF %FMTINPUT%==1 (
	SET FORMAT=iso
	GOTO MODE
	)
IF %FMTINPUT%==2 (
	SET FORMAT=wbfs
	GOTO MODE
	)

GOTO INPUTERROR

:MODE
cls
echo ========GameMode Select=========
echo 1. Normal
echo Just Normal speed.
echo.
echo 2. 200cc
echo Super fast speed!
echo =====Enter the Number corresponding=====
echo ========to the gamemode you want========
SET GMINPUT=
SET /P GMINPUT=Enter Number and press Enter:

IF %GMINPUT%==1 (
	SET G4M3M0D3=nml
	GOTO AYS
	)
IF %GMINPUT%==1 (
	SET G4M3M0D3=200
	GOTO AYS
	)

GOTO INPUTERROR

:AYS
cls
echo ==============Review Settings=============
echo Selected Base Version: %BASEVER%
echo Selected Game Format: %FORMAT%
echo Selected Game Mode: %G4M3M0D3%
echo.
echo ===========Is this selection ok?==========
echo 1. Yes, continue
echo 2. No, change settings
echo (Anything else). exit
echo ==========================================
SET AREYOUSURE=
SET /P AREYOUSURE=Enter Number and press Enter:

IF %AREYOUSURE%==1 GOTO EXTRACT
IF %AREYOUSURE%==2 GOTO BEGIN

GOTO INPUTERROR

:INPUTERROR
echo Invalid option selected, exiting...
pause
exit

:EXTRACT
echo Unpacking original game...
wit.exe extract -s ../ -1 -n %GAMEID% . --DEST rosatemp --psel=DATA -ovv
GOTO PATCH
	)
	
:PATCH
:: Copy like there's no tomorrow
copy /b .\rosa\t\n\ .\rosatemp\files\Race\Course\
IF %G4M3M0D3%==200 copy /b .\rosa\t\s\ .\rosatemp\files\Race\Course\


IF %GAMEID%==RMCE01 (
copy /b .\rosa\m\m\master\MenuSingle.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\m\US\MenuSingle_U.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\t\master\Title.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\t\US\Title_U.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\g\master\Globe.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\g\US\Globe_U.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\g\US\normal\main.dol .\rosatemp\sys\normal\main.dol
copy /b .\rosa\g\US\normal\StaticR.rel .\rosatemp\files\rel\normal\StaticR.rel
IF %G4M3M0D3%==200 copy /b .\rosa\g\US\200cc\main.dol .\rosatemp\sys\normal\main.dol
IF %G4M3M0D3%==200 copy /b .\rosa\g\US\200cc\StaticR.rel .\rosatemp\files\rel\normal\StaticR.rel
GOTO FINISH
)

IF %GAMEID%==RMCP01 (
copy /b .\rosa\m\m\master\MenuSingle.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\m\EU\MenuSingle_E.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\m\EU\MenuSingle_F.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\m\EU\MenuSingle_G.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\m\EU\MenuSingle_I.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\m\EU\MenuSingle_S.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\t\master\Title.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\t\EU\Title_E.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\t\EU\Title_F.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\t\EU\Title_G.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\t\EU\Title_I.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\t\EU\Title_S.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\g\master\Globe.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\g\EU\Globe_E.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\g\EU\Globe_F.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\g\EU\Globe_G.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\g\EU\Globe_I.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\g\EU\Globe_S.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\g\EU\normal\main.dol .\rosatemp\sys\normal\main.dol
copy /b .\rosa\g\EU\normal\StaticR.rel .\rosatemp\files\rel\normal\StaticR.rel
IF %G4M3M0D3%==200 copy /b .\rosa\g\EU\200cc\main.dol .\rosatemp\sys\normal\main.dol
IF %G4M3M0D3%==200 copy /b .\rosa\g\EU\200cc\StaticR.rel .\rosatemp\files\rel\normal\StaticR.rel
GOTO FINISH
)

IF %GAMEID%==RMCJ01 (
copy /b .\rosa\m\m\master\MenuSingle.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\m\JP\MenuSingle_J.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\t\master\Title.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\t\JP\Title_J.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\g\master\Globe.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\m\g\JP\Globe_J.szs .\rosatemp\files\Scene\UI
copy /b .\rosa\g\JP\normal\main.dol .\rosatemp\sys\normal\main.dol
copy /b .\rosa\g\JP\normal\StaticR.rel .\rosatemp\files\rel\normal\StaticR.rel
IF %G4M3M0D3%==200 copy /b .\rosa\g\JP\200cc\main.dol .\rosatemp\sys\normal\main.dol
IF %G4M3M0D3%==200 copy /b .\rosa\g\JP\200cc\StaticR.rel .\rosatemp\files\rel\normal\StaticR.rel
GOTO FINISH
)

:FINISH
:: create new image
mkdir fctp-iso
IF %GAMEID%==RMCE01 SET GAMEID=RMCERK
IF %GAMEID%==RMCP01 SET GAMEID=RMCPRK
IF %GAMEID%==RMCJ01 SET GAMEID=RMCJRK
wit.exe copy rosatemp --DEST rosa-iso/%GAMEID%.%FORMAT% -ovv --disc-id=%GAMEID% --ticket-id=R --tmd-id=R --name "Rosa Kart Wii Normal"
IF %G4M3M0D3%==200 wit.exe copy rosatemp --DEST rosa-iso/%GAMEID%_200.%FORMAT% -ovv --disc-id=%GAMEID% --ticket-id=R --tmd-id=R --name "Rosa Kart Wii 200cc"

:: clean up working directory
rmdir rosatemp /s /q

:: wait to make errors visible
echo Rosa Kart Wii image is complete!

pause
exit